void computeDiffuse(io vec3 SD, in vec3 normal) {

    sampleRCPVar(SKYLIGHT_DIFFUSE_SAMPLES);

    vec3 tangent = vec3(vec2(-normal.y, normal.x) * fInverseLength(normal.xy), 0.0);

	mat3x3 tbn = mat3(tangent, cross(tangent, normal), normal);

    float ditherScale =  dither64 * sampleRCP;

    for (int i = 0; i < SKYLIGHT_DIFFUSE_SAMPLES; ++i) {

        vec2 screenPoint = hammersleyPointMap(i, sampleRCP * i + 1.0, ditherScale);

        float angle = screenPoint.y * tau + ditherScale;

        float xCos = cos(screenPoint.x);
        float xSin = sqrt(-xCos * xCos + 1.0) * pi;

        SD = computeSkyRayleigh(fNormalize(tbn * vec3(vec2(cos(angle), sin(angle)) * xSin, xCos))) * sampleRCP + SD;

    }

}