vec2 computeParallaxCoord(in mat2x2 wrapTexture) {

    vec2 parallaxCoord = texCoord;

    if (vertexAttributes[3].z < 0.0 && fLength(vertexAttributes[3]) < PARALLAX_DISTANCE) {

        parallaxCoord = parallaxAttributes[2];
        
        vec3 parallaxStep = vertexAttributes[3] / PARALLAX_SAMPLES;

        parallaxStep.z /= (PARALLAX_DEPTH * 0.1);

        for (int i = 0; i < PARALLAX_SAMPLES; ++i) {

            parallaxCoord += parallaxStep.xy;

            if (texture2DGradARB(normals, fract(parallaxCoord) * parallaxAttributes[0] + parallaxAttributes[1], wrapTexture[0], wrapTexture[1]).a > parallaxStep.z * i + 1.0) break;
        }

        parallaxCoord = fract(parallaxCoord) * parallaxAttributes[0] + parallaxAttributes[1];
        
    }

    return parallaxCoord;
}