void computeBloomTile(io vec3 tile, c(in int) index) {

	float tileScale = exp2(2.0 + index);

	float LOD = log2(tileScale);

	vec2 padding = sqrt(screenPixelsSize * LOD) * 0.5;

	vec2 bloomCoordinate = downScale(texCoord, tileScale, bloomTilePositions[index] * (padding * 2.0 + 1.0));
	
	if (!coordInTile(bloomCoordinate, padding))
	return;

	tileScale = tileScale * BLOOM_SAMPLE_COUNT_MULTIPLIER;

	float halfScale = tileScale * 0.5;
	     
	for (int i = 0; i < tileScale; ++i) {

		float circularWeight = powEvenInt((tileScale - abs(i - halfScale)) / tileScale, 2);

		if (circularWeight <= 0.0) continue;

		vec3 currentSample = textureLoadLOD(colortex1, rotatePoint(i) * screenPixelsSize + bloomCoordinate, LOD).rgb;

		tile = gammaNonLinear(currentSample) * circularWeight + tile;

	}

	tile /= tileScale;

}
