sampleRCPVar(LENS_EFFECT_SAMPLES * 0.25);
 	
c(float) tauScale = tau * sampleRCP;
c(float) bokehPiScale = (internalScale.z + ROTATION) * sampleRCP;

mat3x2 blurSize = mat3x2(fStop * vec2(1.0, aspectRatio), vec2(0.0), vec2(0.0));
mat2x2 bokehShape = mat2x2(0.0);

mat2x2 coords = mat2x2(0.0);

void computeDiffraction(io vec3 tile, in vec2 coord) {

    c(float) tauScale = tau / BLADES;

    blurSize[1] = blurSize[0] * sampleRCP * (dither01 * 0.75 + 0.75);
    
    float LOD = sampleLOD * 2.0 + dither01;

    vec3 diffraction = vec3(0.0);

    c(float) colorCorrect = sqrt(sampleRCP * 0.25);

    for (int i = 0; i < LENS_EFFECT_SAMPLES; ++i) {

        bokehShape[0] = rotatePoint(i * tauScale) * blurSize[1];

        diffraction = gammaNonLinear(vec3(
        textureLoadLOD(colortex1, bokehShape[0] * dispersion.x + coord, LOD).r,
        textureLoadLOD(colortex1, bokehShape[0] * dispersion.y + coord, LOD).g,
        textureLoadLOD(colortex1, bokehShape[0] * dispersion.z + coord, LOD).b)) + diffraction;

    }

    diffraction = diffraction * colorCorrect;

    tile = diffraction * fInverseLength(diffraction * 0.5 + 0.5) + tile;

}

void computeFlare(io vec3 tile, c(in vec2) distance, c(in vec2) size, in vec2 coord, in vec2 offset) {
    
    coords[0] = fract(coord - offset * distance.x);
    coords[1] = fract(coord - offset * distance.y);

    blurSize[1] = blurSize[0] * distance.x * size.x;
    blurSize[2] = blurSize[0] * distance.y * size.y;

    float LOD = sqrt(exp2(distance.x));

    float colorCorrect = 0;

    vec3 flare = vec3(0.0);

    float fill = 0.0;

	for (int i = 1; i <= RINGS; ++i)

    for (int j = 0; j < i * LENS_EFFECT_SAMPLES * 0.25; ++j) {

        bokehShape[0] = bokehPointMap(dither01 * LOD + j, i, bokehPiScale, tauScale);

        bokehShape[1] = bokehShape[0] * blurSize[1];

        flare = vec3(
        textureLoadLOD(colortex1, bokehShape[1] * dispersion.x + coords[0], LOD).r,
        textureLoadLOD(colortex1, bokehShape[1] * dispersion.y + coords[0], LOD).g,
        textureLoadLOD(colortex1, bokehShape[1] * dispersion.z + coords[0], LOD).b) + flare;

        fill = textureLoadLOD(colortex1, bokehShape[0] * blurSize[2] + coords[1], LOD).r + fill;

        ++colorCorrect;
    }

    colorCorrect = inversesqrt(colorCorrect);

    fill = fill * colorCorrect;
     
    flare = flare * colorCorrect;

    tile = min0(flare - fill) + tile;

}

void computeDirtyLens(io vec3 tile, in vec2 coord) {

    int colorCorrect = 0;

    c(float) upscaledRCP = sampleRCP * 0.75;
    c(float) upscaledPiScale = bokehPiScale * 0.75;
    c(float) upscaledTauScale = tauScale * 0.75;
    c(float) LOD = sampleLOD * 2.0;

    for (int i = 1; i <= RINGS; ++i)

    for (int j = 0; j < i * LENS_EFFECT_SAMPLES * 0.5; ++j) {

        vec2 bokehPoints = bokehPointMap(dither01 * upscaledRCP + j, i, upscaledPiScale, upscaledTauScale) * blurSize[0];

        tile = gammaNonLinear(vec3(
        textureLoadLOD(colortex2, bokehPoints * dispersion.x + coord, LOD).b, 
        textureLoadLOD(colortex2, bokehPoints * dispersion.y + coord, LOD).b, 
        textureLoadLOD(colortex2, bokehPoints * dispersion.z + coord, LOD).b)) + tile;

        ++colorCorrect;
    }

    tile /= colorCorrect;

}