void computeStars(io vec3 output0, in vec3 worldSpacePosition, in vec2 horizon, in float cloudSurface) {

    if (horizon.x >= 0.1) {

        vec2 starPlane = time * 0.001 + worldSpacePosition.xz;

        float starVisibility = 100.0 * horizon.y * timeNight * (1.0 - cloudSurface);

        float stars = generate2DNoise(starPlane * 600.0) * 0.24;

        stars = generate2DNoise(starPlane * 840.0) * 0.15 + stars;

        stars = generate2DNoise(starPlane * 850.0) * 0.05 + stars;

        output0 = clamp01(stars * 0.9 - 0.35) * starVisibility + output0;

    }
}