void computeRaytracedCoordinates(io vec3 rayCoord, io bool hit, io int refinements, in positionStruct Position) {
	
	c(float) rayIncrement = 1.6;
	c(float) rayStepBack = 0.4;

    for (int i = 0; i < WATER_REFLECTION_RAYS; ++i) {

        rayCoord = projMAD3(gbufferProjection, Position.viewSpacePosition[0]) / (gbufferProjection[2].w * Position.viewSpacePosition[0].z + gbufferProjection[3].w) * 0.5 + 0.5;
    
		if (!coordInTile(rayCoord.xy)) break;

		vec3 reflectedViewSpacePosition = projectViewSpace(rayCoord.xy, textureLoad(depthtex1, rayCoord.xy).r, 1.0, gbufferProjectionInverse);

		if (fDistance(Position.viewSpacePosition[0], reflectedViewSpacePosition) < fLength(Position.reflectedRay[0]) * 2.0) {

			Position.viewSpacePosition[0] = Position.viewSpacePosition[1];

			Position.reflectedRay[0] *= rayStepBack;

			++refinements;

		}
        
		if (refinements >= WATER_REFLECTION_REFINEMENTS) {

			hit = true;

			break;

		}

		Position.reflectedRay[0] *= rayIncrement;

		Position.viewSpacePosition[1] = Position.viewSpacePosition[0];
		Position.viewSpacePosition[0] += Position.reflectedRay[0];
	}
}