#version 120

#define VERTEX

attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

varying vec4 colorInput;

varying vec3 vertexAttributes;

varying vec2 lightmapInput;

uniform vec3 cameraPosition;

uniform mat4 shadowModelView;
uniform mat4 shadowModelViewInverse;

uniform float frameTimeCounter;

#include "/lib/shaderUtilities.glsl"

#include "/lib/asset/shadow.glsl"

#include "/lib/utility/misc/displaceVertex.glsl"

flat(vec3) normalInput;

flat(float) IDInput;

void main() {

	texCoord 	  = gl_MultiTexCoord0.xy;
    lightmapInput = gl_MultiTexCoord1.xy * rcp8bit + rcp8bit;
    normalInput   = gl_NormalMatrix * gl_Normal;
	colorInput    = gl_Color;
	IDInput       = mc_Entity.x;

    mat2x3 position = mat2x3(0.0);

	position[0] = transMAD(shadowModelViewInverse, transMAD(gl_ModelViewMatrix, gl_Vertex.xyz));

	position[1] = position[0].xyz + cameraPosition;

	#ifdef VERTEX_DISPLACEMENT
		if (
		IDInput == 141.0 ||
		IDInput == 142.0 ||
		IDInput == 115.0 ||
		IDInput == 105.0 ||
		IDInput == 104.0 ||
		IDInput == 59.0  ||
		IDInput == 51.0	 ||
		IDInput == 40.0  ||
		IDInput == 39.0  ||
		IDInput == 38.0  ||
		IDInput == 37.0	 ||
		IDInput == 31.0  ||
		IDInput == 32.0  ||
		IDInput == 30.0	 ||
		IDInput == 6.0	 )
		displaceVertex(position[0], lightmapInput.y, 0.75, true);

		if (
		IDInput == 161.0 || 
		IDInput == 106.0 ||
		IDInput == 18.0  )
		displaceVertex(position[0], lightmapInput.y, 0.25, false);

		if (
		IDInput == 175.0 ||
		IDInput == 83.0  )
		displaceVertex(position[0], lightmapInput.y, 0.1, false);

		if (
		IDInput == 141.0 ||
		IDInput == 142.0 ||
		IDInput == 115.0 ||
		IDInput == 59.0  ||
		IDInput == 38.0  ||
		IDInput == 37.0	 ||
		IDInput == 31.0  &&
        fLength(position[0]) < 2.0 && texCoord.y < mc_midTexCoord.y)
        position[0].xz *= 2.0 - clamp01(fLength(position[0] - vec3(0.0, 0.5, 0.0)));
	#endif

    vertexAttributes = position[1].xyz;

	position[0] = transMAD(shadowModelView, position[0]);

	gl_Position = diagonal4(gl_ProjectionMatrix);
	
	gl_Position.xy = position[0].xy * gl_Position.xy;

	gl_Position.zw = position[0].zz * gl_Position.zw + gl_ProjectionMatrix[3].zw;

    gl_Position.xyz = distortShadowSpace(gl_Position.xyz, shadowDistanceSize, inverseDistanceSize);

}